/*
 * Copyright (c) 2005-2010 KOM – Multimedia Communications Lab
 *
 * This file is part of PeerfactSim.KOM.
 *
 * PeerfactSim.KOM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * PeerfactSim.KOM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with PeerfactSim.KOM.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package de.tud.kom.p2psim.impl.analyzer.metric.spatial;

import java.util.ArrayList;
import java.util.List;

import de.tudarmstadt.maki.simonstrator.api.common.metric.AbstractMetric;
import de.tudarmstadt.maki.simonstrator.api.common.metric.ActiveSpatialMetric;
import de.tudarmstadt.maki.simonstrator.api.common.metric.Metric;

public abstract class AbstractSpatialMetric<T extends AbstractSpatialMetricValue<?>> extends AbstractMetric<T> implements Metric<T>, ActiveSpatialMetric<T> {

    protected boolean aggregate = false;

    public AbstractSpatialMetric(String pDescription, MetricUnit pUnit) {
        super(pDescription, pUnit);
    }

    public AbstractSpatialMetric(String pName, String pDescription, MetricUnit pUnit) {
        super(pName, pDescription, pUnit);
    }

    protected void setOverallMetric(T aggregate) {
        super.setOverallMetric(aggregate);
    }

    @Override
    public boolean isAggregated() {
        return aggregate;
    }

    private List<ActiveSpatialMetricListener> _listeners = new ArrayList<>();

    @Override
    public void addActiveSpatialMetricListener(ActiveSpatialMetricListener pListener) {
        _listeners.add(pListener);
    }

    @Override
    public void notifyListeners() {
        for (ActiveSpatialMetricListener activeSpatialMetricListener : _listeners) {
            activeSpatialMetricListener.onMetricUpdate(this);
        }
    }

}
